
; RANDOM CONVERSATIONS

randomgoodbye:
  call loadrandgoodbye
  jp statusbarprintparagraph

loadrandgoodbye:
  ;ld hl,quest_vector_goodbyes
  ld b,num_rand_goodbyes
  call randmax32
  add s_str_goodbye1 ; LOAD FIRST GOODBYE POSITION AND ADD RANDOM OFFSET
  ld l,a
  jp getstringhl     ; GET STRING INTO HL

; CONSTRUCTS DICTIONARY WORDS TOGETHER TO MAKE RANDOM PHRASE

random_greeting: 
  defb 13
  defb 0  :subject_str
  defb " ",13
  defb 0  :verb1_str
  ; OBJECT STR
  defb " "
random_greeting_short: ; SHORTER PHRASE - CUT OUT "A BUDDY ONCE SAID"
  defb 11
  defb " IS ",18:adjstr
  ;defb 0  verb2_str
  defb " ",13
  defb 0  :prep_str
  defb 255

randomgreeting:
    ;call advanceromance ; TEMPORARY TO TEST WIFE FUNCTION QUICKLY
    ; SUBJECT
    ld b,randomthought1len
    call randmaxnoseed
    ld hl,randomthought1
    call vectorlookupsingle
    ld (subject_str-1),a

    ; VERB
    ld b,randomthought6len
    call randmaxnoseed
    ld hl,randomthought6
    call vectorlookupsingle
    ld (verb1_str-1),a

    ; PREPOSITION
    ld b,randomthought5len
    call randmaxnoseed
    ld hl,randomthought5
    call vectorlookupsingle
    ld (prep_str-1),a

    ; OBJECT - GET INTO DE
    ld b,rand_quest_objects
    call randmaxnoseed
    or a ; DON'T ALLOW ID 0 - WHICH IS EMPTY
    jr nz,skipincrementobjectid
    inc a
    skipincrementobjectid:
    ld b,a ; STORE A
    ld hl,rand_quest_object_strs
    call vectorlookup
 
    ; CHANGE CONVERSATION BASED ON WHETHER ITEM IS FOOD OR TOOL
    ; 18 = FOOD, 19 = TOOL, 20 = USEFUL ITEM  
    ld hl,foodortoolbyitemid
    ld a,b ; RESTORE A
    call vectorlookupsingle
    bit 0,a
    jr z,skipfoodid
    ld a,18
    jr aiconvfinish
    skipfoodid:
    bit 1,a
    jr z,skiptoolid
    ld a,19
    jr aiconvfinish
    skiptoolid:
    ld a,20

    ;and %00001111 ; SINGLE OUT ONLY ITEM DESCRIPTION ID
    ;add 18        ; CONVERT 0,1,2 TO 18,19,20
    ;ld (adjstr-1),a
    
    aiconvfinish:
    ld (adjstr-1),a

    ; PRINT RESULT
    call randnoseed
    add 130
    jr c,dolonggreet
    ld hl,random_greeting_short
    jp statusbarprintparagraph
    dolonggreet:
    ld hl,random_greeting
    jp statusbarprintparagraph

; THESE ARE LOOKUP TABLES, CONTAINING THE DICTIONARY ID OF WORDS SUITABLE TO BUILD RANDOM CONVERSATIONS
; THE IDS ARE PASTED TOGETHER TO MAKE A SENTENCE

; SUBJECT
randomthought1len equ 4
randomthought1:
  defb abuddy   ; A BUDDY
  defb somebody ; SOMEBODY
  defb awiseman ; A WISE MAN
  defb afriend  ; A FRIEND

; VERBS
randomthought6len equ 3
randomthought6:
  defb saidthat ; SAID THAT
  defb oncesaid ; ONCE SAID
  defb toldme   ; TOLD ME

; VERBS - FOOD
;randomthought4len equ 2
;randomthought4
;  defb arenice    ; ARE NICE
;  defb tastegreat ; TASTE GREAT

; VERBS - TOOL
;randomthought7len equ 2
;randomthought7
;  defb ishelpful ; IS HELPFUL
;  defb comesinhandy ; COMES IN HANDY

; VERBS - MAP, FLIPPERS ETC
;randomthought8len equ 1
;randomthought8
;  defb canhelpyougetaround ; CAN HELP YOU GET AROUND

; PREPOSITION
randomthought5len equ 5
randomthought5:
  defb inthespring    ; IN THE SPRING
  defb forbreakfast   ; FOR BREAKFAST
  defb atnight        ; AT NIGHT
  defb atsuppertime   ; AT SUPPERTIME
  defb withcornflakes ; WITH CORNFLAKES
