; ADVANCE DAMAGE LEVEL OF TREE
advancedamage:
  push ix
  push bc
  push de
  call findexistingdamageslot_cf
  jr nc,docreatenewdamageslot
  call decexistingdamageslot_cf
  finishdamageloop:
  pop de
  pop bc
  pop ix
ret

docreatenewdamageslot:
  call createnewdamageslot
  jr finishdamageloop

;---------------------------------------------------
;ARROWS
;---------------------------------------------------

; IX = PARENT CHARACTER
; IY = WEAPON SPAWNED
spawnarrow: 
  ld a,(ix+6)
  ; COPY X BYTE COORD
  ; COPY Y LINE COORD
  ; COPY CURRENT DIRECTION OF PLAYER
  ld (iy+6),a
  ld a,(ix+7)
  ld (iy+7),a
  ld a,(ix+8)
  ld (iy+8),a

  ld a,(ix+26)              ; ID OF SPRITE THAT FIRED
  ld (iy+14),a              ; SO WE DON'T HARM OURSELVES

  ld (iy+26),1              ; SET SPRITE ID FOR BUFFER FOR PLAYER ARROW
 
  finishspawnarrow:
  ld (iy+0),3               ; ACTIVATE AS ARROW SPRITE
  ; COPY IN BUILDING
  ; COPY X MAP COORD
  ; COPY Y MAP COORD
  ld a,(ix+3)               ; COPY COORDINATES
  ld (iy+3),a
  ld a,(ix+4)
  ld (iy+4),a
  ld a,(ix+5)
  ld (iy+5),a

  ld (iy+10),anim_arrowleft ; SET IMAGES
  ld (iy+11),anim_arrowup
  ld (iy+12),anim_arrowup
  ld (iy+24),3              ; MOVE IN STRAIGHT LINE
  ld (iy+27),3              ; SPRITE TYPE FOR OBJECT COLLISION - WEAPON
ret

firemcparrow:
  ; ONLY FIRE IF WEAPON CURRENTLY NOT BEING FIRED
  ld iy,playerarrowdata
  ld a,(iy+0)
  or a 
  ret nz
  call spawnarrow
  ld (iy+26),2              ; SET SPRITE ID FOR BUFFER FOR ENEMY ARROW
  jp arrowsound  

firearrow:
  ; CHECK IF FIRING PICKAXE
  ld b,pickaxe_id              ; CHECK FOR PICKAXE
  call checkplayerinvrand_active_cf
  jr c,dofirepickaxe

  ; CHECK IF FIRING AXE
  ld b,axe_id                  ; CHECK FOR LONGBOW
  call checkplayerinvrand_active_cf
  jr c,dofireaxe

  ; CHECK IF WE HAVE ARROWS
  ld b,arrow_id
  call checkplayerinvrand_cf
  ret nc ; WE HAVE NO ARROWS LEFT

  ; ONLY FIRE ARROW IF WE HAVE BOW
  ld b,bow_id                      ; CHECK FOR BOW
  call checkplayerinvrand_active_cf
  jr c,dofirearrow
  ld b,longbow_id                  ; CHECK FOR LONGBOW
  call checkplayerinvrand_active_cf
  ret nc

  dofirearrow:
  ld b,arrow_id
  call remplayerinvrand ; REMOVE ARROW FROM RANDOM INVENTORY LIST
  domyspawnarrow:
  ld ix,playerspritedata
  ld iy,spritemem1 ;ncparrowdata
  call spawnarrow
  jp arrowsound  

  ; DISPLAY AXE BRIEFLY
  dofireaxe:
  call domyspawnarrow
  ld a,anim_axeleft
  finishspawnweapon:
  ld (iy+10),a             ; SET IMAGE
  ld (iy+11),a
  ld (iy+12),a
  ld (iy+9),7              ; SET MOVE COUNTER
  ld (iy+24),4             ; EXPIRE AFTER ONE MOVEMENT
  jp arrowsound   

  ; DISPLAY PICKAXE BRIEFLY
  dofirepickaxe:
  call domyspawnarrow
  ld (iy+0),4                  ; SET AS PICKAXE OBJECT
  ld a,anim_pickaxeleft
  jr finishspawnweapon

;---------------------------------------------------
;OBJECT COLLISION
;---------------------------------------------------

; CHECK IF POINT IS IN HIT BOX
; IN 4 BYTES X
; IN 8 LINES Y
; INPUTS
; D = X BYTE (OUR SPRITE)
; E = Y LINE (OUR SPRITE)
; A = X BYTE 2 (OTHER SPRITE)
; C = Y LINE 2 (OTHER SPRITE)
; OUTPUT
; A = 0 NO HIT, 1 HIT, 2 GRAZE, 3 AWARE ZONE - NOT WORKING
checkinhitbox:
  ; CHECK X HIT BOX
  ld h,hitboxtablexh 
  sub d               ; FIND NUMBER OF PIXELS DIFFERENCE BETWEEN X BYTES

  ld l,a
  ld a,(hl)
  or a
  ret z               ; IF 0 RESULT, WE ARE NOT TOUCHING. ELSE CHECK Y LINE

  ld d,a              ; BACK UP A IN D. WE NEED TO CHECK THIS LATER TO GET THE MAXIMUM OF THE TWO RESULTS
                      ; IF WE DON'T DO THIS THEN WE MIGHT THINK WE HAVE GRAZED AN OBJECT IN X BUT WE HAVE ONLY ENTERED ITS AWARE ZONE IN Y

  ; CHECK Y HIT BOX
  ld h,hitboxtableyh
  ld a,c 
  sub e               ; FIND NUMBER OF PIXELS DIFFERENCE BETWEEN Y LINE
  ld l,a
  ld a,(hl)           ; LOAD RESULT OF Y

  or a
  ret z               ; IF 0 RESULT, WE ARE NOT TOUCHING. ELSE CHECK Y LINE

  sub d               ; COMPARE D WITH A TO FIND OUT WHICH IS THE LARGER FIGURE AND RETURN IT
  jr nc,returndvariable
  add d               ; A IS LARGER, RETURN IT INSTEAD
  ret

returndvariable:
  ld a,d
  ret

; INPUTS
; IX = CURRENT MOVING SPRITE
; CYCLE IY AGAINST ALL SPRITES TO CHECK FOR COLLISIONS
; D = X POS OF OUR SPRITE
; E = Y POS OF OUR SPRITE
checkcollisionsprite_cf:
  ld (ix+28),0 ; RESET COLLISION DETECTION FOR THIS SPRITE  0 = OK, 1 = DO NOT MOVE
  ; UNWRAPPED LOOP
  ld iy,spritemem1 ;ncparrowdata;mcps;ncpsspritedata
  call checkcollisionspriteloop
  ld iy,spritemem2 ;ncparrowdata+sizespriteblock
  call checkcollisionspriteloop
  ld iy,spritemem3 ;ncparrowdata+sizespriteblock+sizespriteblock
  call checkcollisionspriteloop
  ld iy,spritemem4 ;ncparrowdata+sizespriteblock+sizespriteblock+sizespriteblock
  call checkcollisionspriteloop
  ld iy,spritemem5 ;ncparrowdata+sizespriteblock+sizespriteblock+sizespriteblock+sizespriteblock
  call checkcollisionspriteloop
  ld iy,spritemem6 ;ncparrowdata+sizespriteblock+sizespriteblock+sizespriteblock+sizespriteblock+sizespriteblock
  call checkcollisionspriteloop
  ld iy,spritemem7 ;ncparrowdata+sizespriteblock+sizespriteblock+sizespriteblock+sizespriteblock+sizespriteblock+sizespriteblock

  checkcollisionspriteloop:
    ld a,(iy+0)                   
    or a                            ; INACTIVE SKIP
    ret z

    ld a,(iy+26)                    ; SKIP IF WE ARE CHECKING OURSELVES
    cp (ix+26)
    ret z

    bit 1,(iy+2)                    ; CHECK IF OTHER SPRITE HAS BUFFER - IF SPRITE IS DRAWN ON SCREEN
    ret z

    ; GET X POS OF SPRITE TO CHECK
    ld a,(iy+7)                     ; GET Y POS FROM OTHER SPRITE
    add 8                           ; MOVE Y COL DETECTION TO MIDDLE OF SPRITE
    ld c,a
    ld a,(iy+6)                     ; GET X POS FROM OTHER SPRITE
    add 2                           ; MOVE X COL DETECTION TO MIDDLE OF SPRITE

    push de                         ; PRESERVE OUR SPRITE'S COORDINATES
    call checkinhitbox
    pop de
    or a
    ret z                           ; NO COLLISION, JUST RETURN

    ; BELOW FUNCTIONS MUST RETURN TO LOOP
    ; IF AN ARROW MATCHES THE X COORD OF THE PLAYER, IT WILL RETURN WITHOUT CHECKING ANY OTHER
    ; SPRITES FOR COLLISIONS. WE NEED TO KEEP CHECKING OTHER SPRITES.

    dec a;cp 1;dec a;cp 1                            
    jr z,checkkill_cf               ; COLLISION - CHECK IF ONE OBJECT IS ARROW
    ;cp 2;dec a;cp 2
    ; PREVENT SPRITE FROM COMING TO CLOSE TO ANOTHER SPRITE TO
    ; STOP SCREEN CORRUPTION, UNLESS IT IS AN OBJECT TO PICK UP
    ; OR AN ARROW SPRITE THAT NEEDS TO MAKE CONTACT WITH THE SPRITE
    checkgraze_cf:
      ld a,(ix+27)
      or a                                    ; IF PLAYER
      jr z,checkgrazeplayerandobj_cf
      dec a;cp 1                              ; IF NCP
      jr z,checkgrazeanimalandobj_cf
      dec a;cp 2                              ; IF ANIMAL
      jr z,checkgrazeanimalandobj_cf    
      dec a;cp 3                              ; IF ARROW ALLOW TO GRAZE ANYTHING
      jp z,returnfalse2
      dec a;cp 4
      jr z,dontallowpassthru
      dec a;cp 5                              ; IF MOVEABLE OBJECT
      jp z,checkgrazemoveableobj_cf      
      dontallowpassthru: 
      ld (ix+28),1                      ; DO NOT ALLOW PASS THROUGH
    ret                               
  ;ret
    ;cp 3
    ;jr checkaware                 ; WE WALKED INTO AWARE ZONE

    ; IF PLAYER WALKED IN TO GUARD'S AWARE ZONE, CHANGE GUARD TO BOUNTY HUNTER

    ;checkaware
  ;  ld a,(ix+15)
  ;  cp 1 ; IF GUARD
  ;  jr z,checkguardandplayer_cf
    ;jr nextcheckcollisionsprite
    ; IF ANY OTHER SPRITE
    ;or a                       ; CLEAR CARRY FLAG - ALLOW PASS THROUGH
    ;ret 

    ;nextcheckcollisionsprite:
    ;ld bc,sizespriteblock
    ;add iy,bc
  ;jr checkcollisionspriteloop

  ;checkguardandplayer_cf:        
  ;  ld a,(iy+27)             ; IS IT THE PLAYER IN THE AWARE ZONE?
  ;  or a
  ;  jr nz,nextcheckcollisionsprite                   ; NOPE, OTHERWISE...           
  ;  ; GUARD AWARE OF PLAYER!
  ;  ld (ix+24),2  ; SET GUARD TO MOVE TOWARD PLAYER
  ;  ld (ix+9),1   ; SET GUARD TO MOVE IMMEDIATELY
  ;  set 6,(ix+2)  ; SET GUARD AS BOUNTY HUNTER
  ;  or a          ; CLEAR CARRY FLAG - ALLOW PASS THROUGH
  ;jr nextcheckcollisionsprite
  ;ret


    ; cp 2
    ; GRAZE - FORCE OTHER SPRITE TO REDRAW



checkgrazeplayerandobj_cf:
    ld a,(iy+27)  
    dec a;cp 1                  
    jp z,speaktoperson         ; MAKE PERSON RUN FROM PLAYER
    dec a;cp 2                   
    jp z,chaserabbit_cf        ; MAKE RABBIT RUN FROM PLAYER
    dec a;cp 3                  
    jp z,returnfalse2          ; ALLOW ARROW TO GRAZE ANYTHING - ONLY DIRECT HIT COUNTS
    dec a;cp 4                  
    jp z,pickupobj_cf          ; PLAYER GRAZED PICKABLE OBJECT
    dec a;cp 5                
    jp z,moveobject_cf         ; PLAYER GRAZED MOVEABLE OBJECT
    ld (ix+28),1               ; DO NOT ALLOW TO PASS THROUGH
    ret                        

checkgrazeanimalandobj_cf:
    ld a,(iy+27)  
    or a                       ; ANIMAL GRAZED PLAYER - ANIMAL RUNS AWAY
    jp z,chaserabbitix_cf
    cp 2                  
    jp z,chaserabbit_cf        ; ANIMAL/PERSON GRAZED ANIMAL
    cp 3                  
    jp z,returnfalse2          ; ANIMAL/PERSON GRAZED ARROW - PASS THROUGH
    cp 4
    jp z,returnfalse2          ; ANIMAL/PERSON GRAZED PICKABLE OBJECT - PASS THROUGH
    ld (ix+28),1               ; DO NOT ALLOW TO PASS THROUGH
    ret                        

checkgrazemoveableobj_cf:
    ld a,(iy+27)  
    dec a;cp 1                  
    jp z,chaserabbit_cf        ; MOVEABLE OBJECT GRAZED PLAYER
    dec a;cp 2                  
    jp z,chaserabbitix_cf      ; MOVEABLE OBJECT GRAZED ANIMAL - ANIMAL RUNS AWAY
    dec a;cp 3                  
    jp z,returnfalse2          ; MOVEABLE OBJECT GRAZED ARROW - PASS THROUGH
    dec a;cp 4
    jp z,returnfalse2          ; MOVEABLE OBJECT GRAZED PICKABLE OBJECT - PASS THROUGH
    dec a;cp 5                
    jp z,moveobject_cf         ; MOVEABLE OBJECT GRAZED MOVEABLE OBJECT
    ld (ix+28),1               ; DO NOT ALLOW TO PASS THROUGH
    ret                        

; CHECK IF WE NEED TO KILL ANIMAL AFTER COLLISION
; INPUTS 
; IX = MOVING SPRITE
; IY = COLLISION SPRITE
; RESULTS
; A = 0 NO COLLISION, 1 = COLLISION

; OBJECT TYPES
; 0 = PLAYER
; 1 = GAME CHARACTER
; 2 = ANIMAL THAT CAN BE KILLED
; 3 = ARROW PLAYER (WEAPON - MAY BE AXE TOO)
; 4 = PICKABLE OBJECT - MEAT
; 6 = MOVEABLE OBJECT

; AS ARROW IS MOVING MUCH FASTER THAN CHARACTERS, IT IS
; EXTREMELY UNLIKELY THAT A PLAYER WILL BUMP INTO AN ARROW'S
; KILL ZONE FIRST. SO WE ONLY CHECK TO SEE IF AN ARROW HAS
; HIT ANY PERSON OR PLAYER OR RABBIT, AND NOT THE OTHER WAY AROUND

checkkill_cf:
  ld a,(ix+27)
  or a ; IF PLAYER
  jr z,checkkillplayerandobj_cf
  dec a;cp 1 ; IF PERSON
  jr z,checkkillpersonandobj_cf
  dec a;cp 2 ; IF ANIMAL
  jr z,checkkillrabbitandobj_cf
  dec a;cp 3 ; IF ARROW
  jr z,checkkillarrowandobj_cf
  dec a;cp 4 ; IF PICKABLE OBJECT
  ret z
  dec a;cp 5 ; IF MOVEABLE OBJECT
  jp z,checkkillmoveableobj_cf       
  ; IF ANY OTHER SPRITE - ALLOW TO PASS THROUGH
  ret 

  checkkillarrowandobj_cf:
    ld a,(iy+27)  
    or a
    jr z,killplayeriy_cf        ; ARROW COLLIDED WITH PLAYER - CHECK WHO FIRED IT
    dec a;cp 1  
    jp z,killpersoniy_cf        ; ARROW COLLIDED WITH PERSON - CHECK WHO FIRED IT
    dec a;cp 2 
    jr z,turnrabbittofoodiy_cf  ; ARROW COLLIDED WITH RABBIT  
    ;cp 5  
    ;jp z,turnrabbittofoodiy_cf  ; ARROW COLLIDED WITH MOVEABLE OBJECT - CHECK WHO FIRED IT  
    ;or a
    ret                         ; ALLOW TO PASS THROUGH
 
  checkkillplayerandobj_cf:
    ld a,(iy+27)
    cp 2
    jp z,chaserabbit_cf       ; PLAYER COLLIDED WITH RABBIT - CHASE IT
    cp 4
    jp z,pickupobj_cf         ; PLAYER COLLIDED WITH PICKABLE OBJECT
    cp 5                
    jp z,moveobject_cf        ; PLAYER COLLIDED WITH MOVEABLE OBJECT
    ld (ix+28),1              ; COLLIDED WITH OBSTACLE   
    ret                          
  
  checkkillrabbitandobj_cf:
    ld a,(iy+27)
    or a                       ; ANIMAL COLLIDED PLAYER - ANIMAL RUNS AWAY
    jp z,chaserabbitix_cf
    cp 2
    jp z,chaserabbit_cf        ; RABBIT COLLIDED WITH RABBIT - CHASE IT
    ;cp 3
    ;jp z,turnrabbittofoodiy_cf ; RABBIT COLLIDED WITH ARROW
    ld (ix+28),1               ; RABBIT COLLIDED WITH OBSTACLE 
    ret                        

  checkkillpersonandobj_cf:        
    ld a,(iy+27)
    cp 2
    jp z,chaserabbit_cf        ; PERSON COLLIDED WITH RABBIT - CHASE IT
    cp 4
    jp z,returnfalse2          ; PERSON COLLIDED WITH PICKABLE OBJECT
    ld (ix+28),1              ; PERSON COLLIDED WITH OBSTACLE 
    ret                       

  checkkillmoveableobj_cf:
    ld a,(iy+27)
    ;or a
    ;jp z,moveobject_cf         ; MOVEABLE OBJECT COLLIDED WITH PLAYER - CHASE IT
    cp 1
    jp z,moveobject_cf         ; MOVEABLE OBJECT COLLIDED WITH PERSON - CHASE IT
    cp 2
    jp z,chaserabbit_cf        ; MOVEABLE OBJECT COLLIDED WITH RABBIT - CHASE IT
    cp 5
    jp z,moveobject_cf         ; MOVEABLE OBJECT COLLIDED WITH MOVEABLE OBJECT - CHASE IT
    ld (ix+28),1               ; MOVEABLE OBJECT COLLIDED WITH OBSTACLE 
    ret                        


turnrabbittofoodiy_cf:
  ; JUST IN CASE WE HAVE RABBITS THAT FIRE ARROWS
  ;ld a,(ix+14)                       ; MATCH ID OF ARROW WITH ARROW OF THIS CHARACTER - IF SAME, THEN DO NOT KILL
  ;cp (iy+26)
  ;jp z,returnfalse2

  ld (iy+8),0                        ; SET DIRECTION TO STATIONARY
  ld (iy+24),3                       ; SET MOVEMENT TO STRAIGHT
  ld (iy+18),rabbitmeat              ; SET OBJECT ID TO MEAT 
  ld (iy+27),4                       ; SET OBJECT TYPE TO PICKUPABLE OBJECT
  res 3,(iy+2)                       ; SET TO REDRAW NEW IMAGE
  set 0,(iy+2)                       ; MARK AS KILLED - WILL BE CLEARED NEXT DAY
  call deactivateandclearsprite
  ;call forceredrawbufferthissprite   ; ERASE WEAPON SPRITE IF WE HIT DESTRUCTABLE OBJECT
  ;call deactivatesprite              ; WE HIT AN OBJECT, DISABLE ARROW
  or a ; CLEAR CARRY FLAG
  ret

; IX = ARROW
; IY = PERSON
killplayeriy_cf:
  ld a,(ix+14)                       ; MATCH ID OF ARROW WITH ARROW OF THIS CHARACTER - IF SAME, THEN DO NOT KILL
  cp (iy+26)
  jp z,returnfalse2
  ; DISABLE ARROW AND ERASE IT
  call deactivateandclearsprite
  call dechealth
  ;getridofarrow
  ;call forceredrawbufferthissprite   ; ERASE WEAPON SPRITE IF WE HIT DESTRUCTABLE OBJECT
  ;call deactivatesprite              ; WE HIT AN OBJECT, DISABLE ARROW
  or a ; CLEAR CARRY FLAG
  ret

; IX = ARROW
; IY = PERSON
killpersoniy_cf:
  ld a,(ix+14)                     ; MATCH ID OF ARROW WITH ARROW OF THIS CHARACTER - IF SAME, THEN DO NOT KILL
  cp (iy+26)
  jp z,returnfalse2

  ld (iy+8),0                      ; SET PERSON DIRECTION TO STATIONARY
  ld (iy+24),3                     ; SET MOVEMENT TO STRAIGHT
  ld (iy+27),5                     ; SET OBJECT TYPE TO OBSTRUCTION
  res 3,(iy+2)                     ; SET TO REDRAW NEW IMAGE
  ld (iy+13),2                     ; VERTICALLY FLIP SPRITE
  set 0,(iy+2)                     ; MARK AS KILLED - WILL BE CLEARED NEXT DAY

  ; DISABLE ARROW AND ERASE IT
  call deactivateandclearsprite
  ;call forceredrawbufferthissprite ; ERASE WEAPON SPRITE IF WE HIT DESTRUCTABLE OBJECT
  ;call deactivatesprite            ; WE HIT AN OBJECT, DISABLE ARROW

  ; CHECK IF PLAYER DID THE DEED - IF NOT DO NOT CHANGE WANTED LEVEL
  ld a,(ix+14)
  or a
  jp nz,returnfalse2
  ; CHECK IF PERSON WAS ENEMY - IF SO DO NOT CHANGE WANTED LEVEL
  ld a,(iy+15)
  cp 1
  ret z

  ; INCREASE WANTED LEVEL
  call makewanted_cf

  or a ; CLEAR CARRY FLAG
  ret

makewanted_cf:
  ; INCREASE WANTED LEVEL
  push bc
  ld hl,(bountyreward-2)
  ld bc,25
  add hl,bc
  ld (bountyreward-2),hl
  ; START SPAWNING BOUNTY HUNTERS IF WE ARE WANTED
  call convertweementobountyhunters
  pop bc
  scf         ; ALLOW MOVEMENT AGAIN IF PICKING UP GOLD FROM BANK
ret

randomgreetfunctiontablelen equ 3
randomgreetfunctiontable:
  defw dorandomgreetname
  defw dorandomgreettown
  defw dorandomgreet

speaktoperson:
  ld hl,watermomentumcount
  ld (hl),0
  ld b,randomgreetfunctiontablelen
  call randmax32
  ld hl,randomgreetfunctiontable
  jp vectortablelaunchcode

  dorandomgreetname:
  ld a,(iy+20)
  ld (myrandomname-1),a
  ld hl,str_mynameis
  jp printstronce

  dorandomgreettown:
  ; CHECK IF WE HAVE DESTINATION
  ld a,(iy+24)                   
  or a
  jr z,dorandomgreet  

  ; GET RANDOM TOWN COORDINATE FROM CHARACTER SO CHARACTER CAN USE NAME OF TOWN IN SPEECH
  ld a,(iy+21)
  ld (deltownx-1),a
  ld a,(iy+22)
  ld (deltowny-1),a
  ld l,s_str_towndesc
  call getstringhl
  jp printstronce

  ; NO DESTINATION, JUST GIVE RANDOM SPEECH
  dorandomgreet:
  call randomgreeting
  jr chaserabbit_cf

; IF PLAYER PUSHES AGAINST CHARACTER, STEP OUT OF WAY
moveobject_cf:
  bit 0,(iy+2)                  ; CHECK IF CHARACTER KILLED, IF SO DON'T MOVE!
  jr nz,dontallowtopass
  ld (iy+9),3                   ; SET MOVE COUNTER TO SMALL MOVEMENT
chaserabbit_cf:
  ld a,(ix+8)                   ; SET DIRECTION TO SAME AS PLAYER TO RUN AWAY
  ld (iy+8),a
  res 3,(iy+2)                  ; MARK THAT WE HAVE MOVED
  dontallowtopass:
  ld (ix+28),1 ;scf                           ; SET CARRY FLAG
  ret                           ; DO NOT ALLOW TO PASS

chaserabbitix_cf:
  ld hl,oppositedirections
  ld c,(ix+8)                   ; SET DIRECTION TO OPPOSITE
  ld b,0
  add hl,bc
  ld a,(hl)
  ld (ix+8),a
  ;res 3,(ix+2)                  ; MARK THAT WE HAVE MOVED
  ;scf                           ; SET CARRY FLAG
  ret                           ; DO NOT ALLOW TO PASS

pickupobj_cf:
  ld b,(iy+18)                  ; GET TILE GRAPHIC ID
  call pickupspriteobject_cf   
  ret nc                        ; WE HAVENT ROOM FOR ANY MORE OBJECTS
  call restoremybufferiy        ; CLEAR SPRITE FROM SCREEN
  call deactivatespriteiy       ; DISABLE MEAT
  or a                          ; CLEAR CARRY FLAG
  ret