;org #4000
;jp addwave
;jp stopwave

addwave:
  ld b,#c1     ; EVENT CLASS
  ld de,wave_routine       ; ADDRESS OF EVENT ROUTINE
  ld hl,frameflybackblock  ; ADDRESS OF FRAME FLYBACK BLOCK
  call #bd19               ; WAIT FLYBACK
  call #bcd7               ; KL_NEW_FRAME_FLY
ret

stopwave:
  ld hl,frameflybackblock  ; ADDRESS OF FRAME FLYBACK BLOCK
  call &BCDD               ; KL DEL FRAME FLY
ret

wave_routine:
  ld b,255
  delay:
  djnz delay

  ld b,255
  delay2:
  djnz delay2

  ld b,255
  delay3:
  djnz delay3

  ld b,255
  delay4:
  djnz delay4

  ld b,#20
  delay5:
  djnz delay5

  ld de,(l40b4)
  ld hl,(l40b6)

  ld a,192; NUMBER OF LINES IN WAVE MOTION? #c0
  ; SHIFT HSYNC
  bigrepeat:
    push af

    ld bc,#7f00
    ld a,(de)
    out (c),c
    out (c),a
    ld c,#10
    out (c),c
    out (c),a

    ld bc,#bc02
    ld a,(hl)
    out (c),c
    inc b
    out (c),a

    inc de
    inc hl

    ld b,#02
    delay6:
    djnz delay6

    ; DELAY AGAIN
    nop
    nop
    nop

    pop af
    dec a
  jr nz,bigrepeat

  ; DELAY AGAIN
  nop
  nop
  nop

  ; THIS MAKES WAVE MOTION
  ld (l40b4),hl
  ld (l40b8),a
  ld hl,(l40b6)
  inc hl
  ld a,(l40b9)
  inc a

  cp 104;#68 ; LENGTH OF WAVE?

  jr nz,skipmovestart
  ld hl,hsyncoffsets;#4200
  xor a

  skipmovestart:
  ld (l40b6),hl
  ld (l40b9),a
ret

;ld hl,l40ba
;call #bcdd
;ret

.l40b4
  add hl,bc
  ld b,c
  .l40b6
  ld d,(hl)
  ld b,d
  ;.l40b9 equ $ + 1
  .l40b8
  ld d,#56

l40b9: db #56

frameflybackblock: db #00,#00,#00,#00,#00,#c1,#1c,#40,#ff

; HSYNC OFFSETS
org #4200
hsyncoffsets:
db #2e,#2e,#2e,#2f,#2e,#2e,#2f,#2e
db #2f,#2e,#2f,#2f,#2e,#2f,#2f,#2f
db #30,#2f,#2f,#30,#2f,#30,#2f,#30
db #30,#2f,#30,#30,#30,#2f,#30,#30
db #2f,#30,#2f,#30,#2f,#2f,#30,#2f
db #2f,#2f,#2e,#2f,#2f,#2e,#2f,#2e
db #2f,#2e,#2e,#2f,#2e,#2e,#2e,#2d
db #2e,#2e,#2d,#2e,#2d,#2e,#2d,#2d
db #2e,#2d,#2d,#2d,#2c,#2d,#2d,#2c
db #2d,#2c,#2d,#2c,#2c,#2d,#2c,#2c
db #2c,#2d,#2c,#2c,#2d,#2c,#2d,#2c
db #2d,#2d,#2c,#2d,#2d,#2d,#2e,#2d
db #2d,#2e,#2d,#2e,#2d,#2e,#2e,#2d
db #2e,#2e,#2e,#2f,#2e,#2e,#2f,#2e
db #2f,#2e,#2f,#2f,#2e,#2f,#2f,#2f
db #30,#2f,#2f,#30,#2f,#30,#2f,#30
db #30,#2f,#30,#30,#30,#2f,#30,#30
db #2f,#30,#2f,#30,#2f,#2f,#30,#2f
db #2f,#2f,#2e,#2f,#2f,#2e,#2f,#2e
db #2f,#2e,#2e,#2f,#2e,#2e,#2e,#2d
db #2e,#2e,#2d,#2e,#2d,#2e,#2d,#2d
db #2e,#2d,#2d,#2d,#2c,#2d,#2d,#2c
db #2d,#2c,#2d,#2c,#2c,#2d,#2c,#2c
db #2c,#2d,#2c,#2c,#2d,#2c,#2d,#2c
db #2d,#2d,#2c,#2d,#2d,#2d,#2e,#2d
db #2d,#2e,#2d,#2e,#2d,#2e,#2e,#2d
db #2e,#2e,#2e,#2f,#2e,#2e,#2f,#2e
db #2f,#2e,#2f,#2f,#2e,#2f,#2f,#2f
db #30,#2f,#2f,#30,#2f,#30,#2f,#30
db #30,#2f,#30,#30,#30,#2f,#30,#30
db #2f,#30,#2f,#30,#2f,#2f,#30,#2f
db #2f,#2f,#2e,#2f,#2f,#2e,#2f,#2e
db #2f,#2e,#2e,#2f,#2e,#2e,#2e,#2d
db #2e,#2e,#2d,#2e,#2d,#2e,#2d,#2d
db #2e,#2d,#2d,#2d,#2c,#2d,#2d,#2c
db #2d,#2c,#2d,#2c,#2c,#2d,#2c,#2c
db #2c,#2d,#2c,#2c,#2d,#2c,#2d,#2c
db #2d,#2d,#2c,#2d,#2d,#2d,#2e,#2d
db #2d,#2e,#2d,#2e,#2d,#2e,#2e,#2d